unit frmmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFrmCCalc = class(TForm)
    SBarHue: TScrollBar;
    SBarSat: TScrollBar;
    SBarIntens: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LblHue: TLabel;
    LblSat: TLabel;
    LblIntens: TLabel;
    PnlRed: TPanel;
    PnlGreen: TPanel;
    PnlBlue: TPanel;
    LblRed: TLabel;
    LblGreen: TLabel;
    LblBlue: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    PnlColor: TPanel;
    EdHTML: TEdit;
    Label7: TLabel;
    ButInvert: TButton;
    procedure SBarIntensChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButInvertClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmCCalc: TFrmCCalc;

implementation

{$R *.dfm}

uses
  SDL_sdlcolors;

(******************************************************************************)
procedure TFrmCCalc.SBarIntensChange(Sender: TObject);
(******************************************************************************)

var
  r,g,b : integer;

begin
HSItoRGB (SBarHue.Position, SBarSat.Position/100, SBarIntens.Position/100, r, g, b);
PnlColor.Color := RGB(r,g,b);
LblHue.Caption := IntToStr (SBarHue.Position);
LblSat.Caption := IntToStr (SBarSat.Position);
LblIntens.Caption := IntToStr (SBarIntens.Position);
LblRed.Caption := IntToStr (r);
LblGreen.Caption := IntToStr (g);
LblBlue.Caption := IntToStr (b);
PnlRed.Color := r;
PnlGreen.Color := 256*g;
PnlBlue.Color := 65536*b;
EdHTML.Text := '#'+IntToHex(RGB(b,g,r),6);
end;


(******************************************************************************)
procedure TFrmCCalc.FormShow(Sender: TObject);
(******************************************************************************)

begin
SBarIntensChange(Sender);
end;

(******************************************************************************)
procedure TFrmCCalc.ButInvertClick(Sender: TObject);
(******************************************************************************)

var
  r,g,b : integer;
  h,s,i : double;

begin
HSItoRGB (SBarHue.Position, SBarSat.Position/100, SBarIntens.Position/100, r, g, b);
r := 255-r;
g := 255-g;
b := 255-b;
RGBtoHSI (r, g, b, h, s, i);
SBarHue.Position := round(h);
SBarSat.Position := round(s*100);
SBarIntens.Position := round(i*100);
end;

end.
